Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util.concurrent
Class PriorityBlockingQueue<E>

    java.lang.Object
      java.util.AbstractCollection<E>
          java.util.AbstractQueue<E>
              java.util.concurrent.PriorityBlockingQueue<E>

Type Parameters:
  `E` - the type of elements held in this collection

All Implemented Interfaces:
  Serializable, Iterable<E>, Collection<E>, BlockingQueue<E>, Queue<E>

    public class PriorityBlockingQueue<E>

extends AbstractQueue<E>
implements BlockingQueue<E>, Serializable

An unbounded blocking queue that uses the same ordering rules as class `PriorityQueue` and supplies blocking retrieval operations. While this queue is logically unbounded, attempted additions may fail due to resource exhaustion (causing `OutOfMemoryError`). This class does not permit `null` elements. A priority queue relying on natural ordering also does not permit insertion of non-comparable objects (doing so results in `ClassCastException`).

This class and its iterator implement all of the optional methods of the `Collection` and `Iterator` interfaces. The Iterator provided in method `iterator()` is not guaranteed to traverse the elements of the PriorityBlockingQueue in any particular order. If you need ordered traversal, consider using `Arrays.sort(pq.toArray())`.

This class is a member of the Java Collections Framework.

Since:
  1.5
See Also:
  Serialized Form

Constructor Summary
`PriorityBlockingQueue()` Creates a `PriorityBlockingQueue` with the default initial capacity (11) that orders its elements according to their natural ordering (using `Comparable`).
`PriorityBlockingQueue(Collection<? extends E> c)` Creates a `PriorityBlockingQueue` containing the elements in the specified collection.
`PriorityBlockingQueue(int initialCapacity)` Creates a `PriorityBlockingQueue` with the specified initial capacity that orders its elements according to their natural ordering (using `Comparable`).
`PriorityBlockingQueue(int initialCapacity, Comparator<? super E> comparator)` Creates a `PriorityBlockingQueue` with the specified initial capacity that orders its elements according to the specified comparator.

Method Summary
`boolean` | `add(E o)` Adds the specified element to this queue.
`void` | `clear()` Atomically removes all of the elements from this queue.
`Comparator<? super E>` | `comparator()` Returns the comparator used to order this collection, or `null` if this collection is sorted according to its elements natural ordering (using `Comparable`).
`boolean` | `contains(Object o)` Returns `true` if this collection contains the specified element.
`int` | `drainTo(Collection<? super E> c)` Removes all available elements from this queue and adds them into the given collection.
`int` | `drainTo(Collection<? super E> c, int maxElements)` Removes at most the given number of available elements from this queue and adds them into the given collection.
`Iterator<E>` | `iterator()` Returns an iterator over the elements in this queue.
`boolean` | `offer(E o)` Inserts the specified element into this priority queue.
`boolean` | `offer(E o, long timeout, TimeUnit unit)` Inserts the specified element into this priority queue.
`E` | `peek()` Retrieves, but does not remove, the head of this queue, returning `null` if this queue is empty.
`E` | `poll()` Retrieves and removes the head of this queue, or `null` if this queue is empty.
`E` | `poll(long timeout, TimeUnit unit)` Retrieves and removes the head of this queue, waiting if necessary up to the specified wait time if no elements are present on this queue.
`void` | `put(E o)` Adds the specified element to this priority queue.
`int` | `remainingCapacity()` Always returns `Integer.MAX_VALUE` because a `PriorityBlockingQueue` is not capacity constrained.
`boolean` | `remove(Object o)` Removes a single instance of the specified element from this queue, if it is present.
`int` | `size()` Returns the number of elements in this collection.
`E` | `take()` Retrieves and removes the head of this queue, waiting if no elements are present on this queue.
`Object[]` | `toArray()` Returns an array containing all of the elements in this collection.
`
`<T> T[]`
` | `toArray(T[] a)` Returns an array containing all of the elements in this collection; the runtime type of the returned array is that of the specified array.
`String` | `toString()` Returns a string representation of this collection.

Methods inherited from class java.util.AbstractQueue
`addAll, element, remove`

Methods inherited from class java.util.AbstractCollection
`containsAll, isEmpty, removeAll, retainAll`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Queue
`element, remove`

Methods inherited from interface java.util.Collection
`addAll, containsAll, equals, hashCode, isEmpty, removeAll, retainAll`

Constructor Detail

### PriorityBlockingQueue

    public PriorityBlockingQueue()

  Creates a `PriorityBlockingQueue` with the default initial capacity (11) that orders its elements according to their natural ordering (using `Comparable`).

### PriorityBlockingQueue

    public PriorityBlockingQueue(int initialCapacity)

  Creates a `PriorityBlockingQueue` with the specified initial capacity that orders its elements according to their natural ordering (using `Comparable`).

  Parameters:
    `initialCapacity` - the initial capacity for this priority queue.
  Throws:
    `IllegalArgumentException` - if `initialCapacity` is less than 1

### PriorityBlockingQueue

    public PriorityBlockingQueue(int initialCapacity,
                                 Comparator<? super E> comparator)

  Creates a `PriorityBlockingQueue` with the specified initial capacity that orders its elements according to the specified comparator.

  Parameters:
    `initialCapacity` - the initial capacity for this priority queue.
    `comparator` - the comparator used to order this priority queue. If `null` then the order depends on the elements' natural ordering.
  Throws:
    `IllegalArgumentException` - if `initialCapacity` is less than 1

### PriorityBlockingQueue

    public PriorityBlockingQueue(Collection<? extends E> c)

  Creates a `PriorityBlockingQueue` containing the elements in the specified collection. The priority queue has an initial capacity of 110% of the size of the specified collection. If the specified collection is a `SortedSet` or a `PriorityQueue`, this priority queue will be sorted according to the same comparator, or according to its elements' natural order if the collection is sorted according to its elements' natural order. Otherwise, this priority queue is ordered according to its elements' natural order.

  Parameters:
    `c` - the collection whose elements are to be placed into this priority queue.
  Throws:
    `ClassCastException` - if elements of the specified collection cannot be compared to one another according to the priority queue's ordering.
    `NullPointerException` - if `c` or any element within it is `null`

Method Detail

### add

    public boolean add(E o)

  Adds the specified element to this queue.

  Specified by:
    `add` in interface `Collection<E>`
  Specified by:
    `add` in interface `BlockingQueue<E>`
  Overrides:
    `add` in class `AbstractQueue<E>`
  Parameters:
    `o` - the element to add
  Returns:
    `true` (as per the general contract of `Collection.add`).
  Throws:
    `NullPointerException` - if the specified element is `null`.
    `ClassCastException` - if the specified element cannot be compared with elements currently in the priority queue according to the priority queue's ordering.

### comparator

    public Comparator<? super E> comparator()

  Returns the comparator used to order this collection, or `null` if this collection is sorted according to its elements natural ordering (using `Comparable`).

  Returns:
    the comparator used to order this collection, or `null` if this collection is sorted according to its elements natural ordering.

### offer

    public boolean offer(E o)

  Inserts the specified element into this priority queue.

  Specified by:
    `offer` in interface `BlockingQueue<E>`
  Specified by:
    `offer` in interface `Queue<E>`
  Parameters:
    `o` - the element to add
  Returns:
    `true`
  Throws:
    `ClassCastException` - if the specified element cannot be compared with elements currently in the priority queue according to the priority queue's ordering.
    `NullPointerException` - if the specified element is `null`.

### put

    public void put(E o)

  Adds the specified element to this priority queue. As the queue is unbounded this method will never block.

  Specified by:
    `put` in interface `BlockingQueue<E>`
  Parameters:
    `o` - the element to add
  Throws:
    `ClassCastException` - if the element cannot be compared with elements currently in the priority queue according to the priority queue's ordering.
    `NullPointerException` - if the specified element is `null`.

### offer

    public boolean offer(E o,
                         long timeout,
                         TimeUnit unit)

  Inserts the specified element into this priority queue. As the queue is unbounded this method will never block.

  Specified by:
    `offer` in interface `BlockingQueue<E>`
  Parameters:
    `o` - the element to add
    `timeout` - This parameter is ignored as the method never blocks
    `unit` - This parameter is ignored as the method never blocks
  Returns:
    `true`
  Throws:
    `ClassCastException` - if the element cannot be compared with elements currently in the priority queue according to the priority queue's ordering.
    `NullPointerException` - if the specified element is `null`.

### take

    public E take()
           throws InterruptedException

  Description copied from interface: `BlockingQueue`
  Retrieves and removes the head of this queue, waiting if no elements are present on this queue.

  Specified by:
    `take` in interface `BlockingQueue<E>`
  Returns:
    the head of this queue
  Throws:
    `InterruptedException` - if interrupted while waiting.

### poll

    public E poll()

  Description copied from interface: `Queue`
  Retrieves and removes the head of this queue, or `null` if this queue is empty.

  Specified by:
    `poll` in interface `Queue<E>`
  Returns:
    the head of this queue, or `null` if this queue is empty.

### poll

    public E poll(long timeout,
                  TimeUnit unit)
           throws InterruptedException

  Description copied from interface: `BlockingQueue`
  Retrieves and removes the head of this queue, waiting if necessary up to the specified wait time if no elements are present on this queue.

  Specified by:
    `poll` in interface `BlockingQueue<E>`
  Parameters:
    `timeout` - how long to wait before giving up, in units of `unit`
    `unit` - a `TimeUnit` determining how to interpret the `timeout` parameter
  Returns:
    the head of this queue, or `null` if the specified waiting time elapses before an element is present.
  Throws:
    `InterruptedException` - if interrupted while waiting.

### peek

    public E peek()

  Description copied from interface: `Queue`
  Retrieves, but does not remove, the head of this queue, returning `null` if this queue is empty.

  Specified by:
    `peek` in interface `Queue<E>`
  Returns:
    the head of this queue, or `null` if this queue is empty.

### size

    public int size()

  Description copied from class: `AbstractCollection`
  Returns the number of elements in this collection. If the collection contains more than `Integer.MAX_VALUE` elements, returns `Integer.MAX_VALUE`.

  Specified by:
    `size` in interface `Collection<E>`
  Specified by:
    `size` in class `AbstractCollection<E>`
  Returns:
    the number of elements in this collection.

### remainingCapacity

    public int remainingCapacity()

  Always returns `Integer.MAX_VALUE` because a `PriorityBlockingQueue` is not capacity constrained.

  Specified by:
    `remainingCapacity` in interface `BlockingQueue<E>`
  Returns:
    `Integer.MAX_VALUE`

### remove

    public boolean remove(Object o)

  Removes a single instance of the specified element from this queue, if it is present.

  Specified by:
    `remove` in interface `Collection<E>`
  Overrides:
    `remove` in class `AbstractCollection<E>`
  Parameters:
    `o` - element to be removed from this collection, if present.
  Returns:
    `true` if the collection contained the specified element.

### contains

    public boolean contains(Object o)

  Description copied from class: `AbstractCollection`
  Returns `true` if this collection contains the specified element. More formally, returns `true` if and only if this collection contains at least one element `e` such that `(o==null ? e==null : o.equals(e))`.

  This implementation iterates over the elements in the collection, checking each element in turn for equality with the specified element.

  Specified by:
    `contains` in interface `Collection<E>`
  Overrides:
    `contains` in class `AbstractCollection<E>`
  Parameters:
    `o` - object to be checked for containment in this collection.
  Returns:
    `true` if this collection contains the specified element.

### toArray

    public Object[] toArray()

  Description copied from class: `AbstractCollection`
  Returns an array containing all of the elements in this collection. If the collection makes any guarantees as to what order its elements are returned by its iterator, this method must return the elements in the same order. The returned array will be "safe" in that no references to it are maintained by the collection. (In other words, this method must allocate a new array even if the collection is backed by an Array). The caller is thus free to modify the returned array.

  This implementation allocates the array to be returned, and iterates over the elements in the collection, storing each object reference in the next consecutive element of the array, starting with element 0.

  Specified by:
    `toArray` in interface `Collection<E>`
  Overrides:
    `toArray` in class `AbstractCollection<E>`
  Returns:
    an array containing all of the elements in this collection.

### toString

    public String toString()

  Description copied from class: `AbstractCollection`
  Returns a string representation of this collection. The string representation consists of a list of the collection's elements in the order they are returned by its iterator, enclosed in square brackets (`"[]"`). Adjacent elements are separated by the characters `", "` (comma and space). Elements are converted to strings as by `String.valueOf(Object)`.

  This implementation creates an empty string buffer, appends a left square bracket, and iterates over the collection appending the string representation of each element in turn. After appending each element except the last, the string `", "` is appended. Finally a right bracket is appended. A string is obtained from the string buffer, and returned.

  Overrides:
    `toString` in class `AbstractCollection<E>`
  Returns:
    a string representation of this collection.

### drainTo

    public int drainTo(Collection<? super E> c)

  Description copied from interface: `BlockingQueue`
  Removes all available elements from this queue and adds them into the given collection. This operation may be more efficient than repeatedly polling this queue. A failure encountered while attempting to `add` elements to collection `c` may result in elements being in neither, either or both collections when the associated exception is thrown. Attempts to drain a queue to itself result in `IllegalArgumentException`. Further, the behavior of this operation is undefined if the specified collection is modified while the operation is in progress.

  Specified by:
    `drainTo` in interface `BlockingQueue<E>`
  Parameters:
    `c` - the collection to transfer elements into
  Returns:
    the number of elements transferred.

### drainTo

    public int drainTo(Collection<? super E> c,
                       int maxElements)

  Description copied from interface: `BlockingQueue`
  Removes at most the given number of available elements from this queue and adds them into the given collection. A failure encountered while attempting to `add` elements to collection `c` may result in elements being in neither, either or both collections when the associated exception is thrown. Attempts to drain a queue to itself result in `IllegalArgumentException`. Further, the behavior of this operation is undefined if the specified collection is modified while the operation is in progress.

  Specified by:
    `drainTo` in interface `BlockingQueue<E>`
  Parameters:
    `c` - the collection to transfer elements into
    `maxElements` - the maximum number of elements to transfer
  Returns:
    the number of elements transferred.

### clear

    public void clear()

  Atomically removes all of the elements from this queue. The queue will be empty after this call returns.

  Specified by:
    `clear` in interface `Collection<E>`
  Overrides:
    `clear` in class `AbstractQueue<E>`

### toArray

    public <T> T[] toArray(T[] a)

  Description copied from class: `AbstractCollection`
  Returns an array containing all of the elements in this collection; the runtime type of the returned array is that of the specified array. If the collection fits in the specified array, it is returned therein. Otherwise, a new array is allocated with the runtime type of the specified array and the size of this collection.

  If the collection fits in the specified array with room to spare (i.e., the array has more elements than the collection), the element in the array immediately following the end of the collection is set to `null`. This is useful in determining the length of the collection only if the caller knows that the collection does not contain any `null` elements.)

  If this collection makes any guarantees as to what order its elements are returned by its iterator, this method must return the elements in the same order.

  This implementation checks if the array is large enough to contain the collection; if not, it allocates a new array of the correct size and type (using reflection). Then, it iterates over the collection, storing each object reference in the next consecutive element of the array, starting with element 0. If the array is larger than the collection, a `null` is stored in the first location after the end of the collection.

  Specified by:
    `toArray` in interface `Collection<E>`
  Overrides:
    `toArray` in class `AbstractCollection<E>`
  Parameters:
    `a` - the array into which the elements of the collection are to be stored, if it is big enough; otherwise, a new array of the same runtime type is allocated for this purpose.
  Returns:
    an array containing the elements of the collection.

### iterator

    public Iterator<E> iterator()

  Returns an iterator over the elements in this queue. The iterator does not return the elements in any particular order. The returned iterator is a thread-safe "fast-fail" iterator that will throw `ConcurrentModificationException` upon detected interference.

  Specified by:
    `iterator` in interface `Iterable<E>`
  Specified by:
    `iterator` in interface `Collection<E>`
  Specified by:
    `iterator` in class `AbstractCollection<E>`
  Returns:
    an iterator over the elements in this queue.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2004 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.